#include "CLuaVM.hpp"
#include "CLuaThread.hpp"
// TODO remove that dependancy
#include "../logging/Logger.hpp"
#include "../core/CStringBuilder.hpp"
#include "../../../src/audio/SAudioParameters.hpp"
#include <luabind/luabind.hpp>
#include <luabind/class_info.hpp>
#include <lua.hpp>

// TODO a supprimer pr après les tests
#include <irrlicht.h>


using namespace luabind;
using namespace detail;


namespace fus
{


//static
// set default message handler
lua_CFunction CLuaVM::MessageHandler = &onLuaError;


//TOnLuaErrorCallback CLuaVM::onLuaErrorFunction = 0;
TOnLuaErrorCallback onLuaErrorFunction = 0;

/*
typedef void (*lua_Hook) (lua_State *L, lua_Debug *ar);
Type for debugging hook functions.
*/
int
onLuaPanic(lua_State *s)
{
    _LOG_ERROR << "LUA PANIC" << "tODO chercher erreur sur la stack";
    // TODO a
    throw std::runtime_error("Lua PANIC");
}



/**
TODO Dump stack
**/
void
stackDump (lua_State *L)
{


    int top = lua_gettop(L);
    printf("\n======================\n");
    if(top == 0){
        printf("Stack empty\n");
    }
    else {
        printf("Stack size (lua_gettop() value ) : [%d]\n",top);
    }

    for (int i = 1; i <= top; i++)
    {  /* repeat for each level */


        //printf("default case");
        int result = 0;
        int t = lua_type(L, i);
        printf("Type [%s] for level [%d]\t", lua_typename(L,t),i);


//lua_tonumberx
//
        switch (t)
        {

            case LUA_TSTRING:  /* strings */
                printf("\nString: [%s]", lua_tostring(L, i));
                break;

            case LUA_TNIL:
                printf("nil");
                break;

            case LUA_TLIGHTUSERDATA:
                //If the value at the given acceptable index is a full userdata, returns its block address.
                //If the value is a light userdata, returns its pointer. Otherwise, returns NULL.
                printf("User data %x", lua_touserdata(L,i) );
                break;

            case LUA_TFUNCTION:
                printf("TODO display function name ?");
                break;

            case LUA_TTHREAD:
                printf("Thread");
                break;

            case LUA_TBOOLEAN:  /* booleans */
                printf(lua_toboolean(L, i) ? "true" : "false");
                break;

            case LUA_TNUMBER:  /* numbers */
                printf("Number [%g]", lua_tonumberx(L, i,&result) );
                if( result == 0){
                    printf("Conversion failed");
                }
                break;

            // TODO http://www.lua.org/source/5.1/lua.h.html
            case LUA_TTABLE:
                // afficher le tableau, les 2/3 premières clés ?
                printf("Table");
                break;

            default:  /* other values */
            //              printf("");
                printf("\nUnhandled case of type [%s]", lua_typename(L, t));
                break;

        }
        printf("\n");  /* put a separator */
    }

}




// TODO should print stack
int
onLuaError(lua_State *L)
{
    std::basic_ostringstream<char> msg;


    _LOG_ERROR << "onLuaError called";

    //std::string error;
//    stackDump(L);


    int top = lua_gettop(L);

    //msg << "\n======================\n";
    if(top == 0)
    {
        msg << "Stack empty\n";
    }
    else
    {
        msg << "Stack size (lua_gettop() value ) : [" << top << "]\n";
    }



    for (int i = 1; i <= top; i++)
    {  /* repeat for each level */


        //printf("default case");
        int t = lua_type(L, i);
        msg << "Level [" << i << "] of type [" << lua_typename(L,t) << "]" ;

        switch (t)
        {

            case LUA_TSTRING:  /* strings */
                msg << lua_tostring(L, i);
                break;

            case LUA_TNIL:
                msg << "Nil value";
                break;

            case LUA_TTHREAD:
                msg << "Thread";
                break;

            case LUA_TBOOLEAN:  /* booleans */
                msg << lua_toboolean(L, i) ? "true" : "false";
                break;

            case LUA_TNUMBER:  /* numbers */
                msg << lua_tonumber(L, i);
                break;

            // TODO http://www.lua.org/source/5.1/lua.h.html
            case LUA_TTABLE:
              // afficher le tableau
                msg << "Table";
                break;

            default:  /* other values */
            //              printf("");
                msg << "Unhandled case ";
                break;

        }
        msg << "\n";
    }

    // TODO chec kca marche
    //luaL_traceback(state,state,"onLuaError called",0);

    //const char *luaL_tolstring (lua_State *L, int idx, size_t *len);
    _LOG_ERROR << luaL_tolstring ( L, -1, 0);

    // push_string
    lua_pushstring(L, msg.str().c_str() );
    // should lua_pushstring( state, );

//    if(onLuaErrorFunction)
//    {
//        _LOG_ERROR << "onLuaErrorFunction defined, should be executed";
//    }

// Returns an error
    return 1;
}



CLuaException::CLuaException(lua_State* L)
{

}

const char* CLuaException::what() const throw()
{
    return "Hello";
}

CLuaException::~CLuaException() throw()
{

};







//lua_State* state
CLuaVM::CLuaVM(lua_State* L) :
    _vm(L)
{
    if(_vm == 0)
    {
        _vm = createVM();
    }

    loadVM( _vm);
    //luabind::set_pcall_callback( onLuaError );
    //registerErrorHandlers();

}


void
CLuaVM::loadVM( lua_State* vm)
{


    // TODO a remplacer par une fct lua
    lua_atpanic ( vm, onLuaPanic);

}


CLuaVM::~CLuaVM()
{

    //luabind::close()
    // BUG ?
    //lua_close(_vm);
    //_INFO << "Lua VM destroyed";
}



//! _vm
lua_State*
CLuaVM::createVM()
{
	// initialize Lua
    lua_State* vm = luaL_newstate();

    // load Lua base libraries
    luaL_openlibs( vm );
    //luaopen_debug(_vm);

    // Connect LuaBind to this lua state
    luabind::open( vm );

    return vm;
}

//
int onNewIndex(lua_State *L)
{
////int specialNewIndex() {

    _INFO << " NEW INDEX FUNCTION CALLED";
}

//// BUG ;
//// Les 2 get_table renvoient rien
//
//    //stackDump(L);
//    // Le stackdump affiche userdata/cle/valeur
//    // en bas de la stack on recupere le lua_touserdata
//	//luabind::
//	//If the value at the given acceptable index is a full userdata, returns its block address. If the value is a light userdata, returns its pointer. Otherwise, returns NULL.
//
//
//
//
//	detail::class_rep* crep = static_cast<detail::class_rep*>(lua_touserdata( L, 1));
//    if(!crep){
//        _LOG_WARNING << "Could not find crep ";
//        return 1;
//    }
//    _INFO << "got crep for class "  << crep->name() ;
//
//    lua_pop(L,3);
//
//
//	// push first table onto the stack (on top of lua user data)
//	// le bug c'est que ca ca push nil
//
//
//	//crep->get_table(L);
//    //_INFO << "Is table (should be table )" << lua_istable( _vm, -1);
//
//	// copy key, then value
//	//lua_pushvalue(L, -3);
//	//lua_pushvalue(L, -3);
//	//stackDump(L);
//
//	// set the value without calling metamethod
//	lua_rawset(L, -3);
//
//
//	// pop table
//	lua_pop(L, 1);
//
//	// get default table
//	crep->get_default_table(L);
//	//Moves the top element into the given position (and pops it), without shifting any element
//	// remplace le userdata en 1 par le tableau
//	//lua_replace(L, 1);
//
//	// cet appel pop ensuite la cle et la value
//	//lua_rawset(L, -3
//	return 0;
//}
//

bool
CLuaVM::setSpecialNewIndex(const char* class_name)
{


    luabind::detail::class_registry* reg  = detail::class_registry::get_registry( _vm );
    luabind::detail::class_rep* rep = reg->find_class( typeid(irr::SIrrlichtCreationParameters) );
    luabind::detail::class_rep* rep_audio = reg->find_class( typeid(audio::SAudioParameters) );
    // _INFO << get_class_name( typeid(irr::SIrrlichtCreationParameters) );



    if(!rep){
        _LOG_WARNING << "could not find a class rep for SIrrlichtCreationParameters";
        return false;
    }
    else {
        _INFO << "found rep for class '" << rep->name() << "'";
        _INFO << "registry: cpp_class" << reg->cpp_class();
        _INFO << "registry: cpp_instance" << reg->cpp_instance();
        _INFO << "registry: lua_instance" << reg->lua_instance();
        _INFO << "registry: lua_class" << reg->lua_class();
    }


    if(!rep_audio)
    {
        _LOG_WARNING << "could not find a class rep for SIrrlichtCreationParameters";
        return false;
    }
    else
    {
        _INFO << "found rep for class '" << rep_audio->name() << "'";
//        _INFO << "registry: cpp_class" << rep_audio->cpp_class();
//        _INFO << "registry: cpp_instance" << rep_audio->cpp_instance();
//        _INFO << "registry: lua_instance" << rep_audio->lua_instance();
//        _INFO << "registry: lua_class" << rep_audio->lua_class();
    }

    int index = rep->metatable_ref();
    _INFO << "class_rep: metatable_ref" << rep->metatable_ref();

    // voici la cle utilise pour acceder au tableau representant la metatable
    lua_pushinteger( _vm, index );
    //Pushes onto the stack the value t[k], where t is the value at the given valid index and k is the value at the top of the stack.
    // Pushes on top of stack the metatable
    lua_gettable(_vm, LUA_REGISTRYINDEX);
    // la on se retrouve avec la metatable sur la stack
//    Returns 1 if the value at the given acceptable index is a table, and 0 otherwise.
    //_INFO << "Is table (should be table )" << lua_istable( _vm, -1);

    lua_pushstring( _vm , "__newindex");
    //    //class_rep::lua_settable_dispatcher
    lua_pushcclosure(_vm, &onNewIndex, 0);
    // set new index
    lua_rawset( _vm, -3);


    // pop le tableau /metatable
    lua_pop( _vm,1);
    return true;
}



bool
CLuaVM::retrieveStringFromStack(std::string& msg)
{


    msg.append(lua_tostring( getVM(), -1) );

    return (!msg.empty());
}





// TODO lua_gettop(L)
//TOnLuaErrorCallback
//void
////CLuaVM::registerErrorHandlers( luabind::pcall_callback_fun onErrorFunction){
//CLuaVM::registerErrorHandlers( TOnLuaErrorCallback& onErrorFunction)
//{
//
//
//
//    //lua_CFunction
//    onLuaErrorFunction = onErrorFunction;
//
//    // TODO
//    //return 0;
//}



void
CLuaVM::getGlobals( luabind::object& g)
{
    g = luabind::globals( this->getVM() );
}


/**
// TODO
int LuaPrint(lua_State *L)
{
	int nArgs = lua_gettop(L);
	int i;
	lua_getglobal(L, "tostring");
	std::string ret;//this is where we will dump the output
	//make sure you start at 1 *NOT* 0
	for(i = 1; i <= nArgs; i++)
	{
		const char *s;
		lua_pushvalue(L, -1);
		lua_pushvalue(L, i);
		lua_call(L, 1, 1);
		s = lua_tostring(L, -1);
		if(s == NULL)
			return luaL_error(L, LUA_QL("tostring") " must return a string to ", LUA_QL("print"));

		if(i > 1) ret.append("\t");

		ret.append(s);
		lua_pop(L, 1);
	};
	ret.append("\n");
	//Send it wherever
	glConsole::GetSingleton().Echo(ret.c_str());
	return 0;
};
[...]
	//same as before register it with the state
	lua_register(MainState, "print", LuaPrint );
	*/
bool
CLuaVM::bind(const luabind::scope& scope)
{

//    try {

        // On peut passer un nom de namespace
        //luabind::module( this->getVM(), "logger" )[
        luabind::module( this->getVM() )[
            scope
        ];
        return true;
//    }
//    //catch(luabind::error& e)
//    catch(...){
//        return false;
//    }
}


int
CLuaVM::saveTopChunkIntoGlobals()
{
    //

    //return luaL_ref(_vm, LUA_GLOBALSINDEX );
    return 0;
    //(_vm)
}




int CLuaVM::pushMessageHandler()
{

    int en = 0;
    if ( MessageHandler )
    {
        int base = lua_gettop(_vm);
        lua_pushcfunction(_vm, MessageHandler);
        lua_insert(_vm, base);  // push pcall_callback under chunk and args
        en = base;
    }

    return en;

}


void
CLuaVM::removeMessageHandler(const int& en)
{
    if ( en )
    {
        lua_remove(_vm, en);  // remove pcall_callback
    }
}




bool
CLuaVM::execute(const int& nbOfParameters,const int& nbOfResults)
{
//    return execute ( this->getVM(), nbOfParameters, nbOfResults);
//}
//
//
//bool
//CLuaVM::execute(lua_State* L, const int& nbOfParameters,const int& nbOfResults)
//{


    /*
If errfunc is 0, then the error message returned on the stack is exactly the original error message. Otherwise, errfunc is the stack index of an error handler function. (In the current implementation, this index cannot be a pseudo-index.) In case of runtime errors, this function will be called with the error message and its return value will be the message returned on the stack by lua_pcall.
*/

// will push the error function  each time
    //int result = luabind::detail::pcall(getVM(), 0, LUA_MULTRET);

    int result = 0;
    int ctx = 0;

    int en = pushMessageHandler();

    //int lua_pcallk (lua_State *L, int nargs, int nresults, int errfunc,int ctx, lua_CFunction k);
//    lua_getctx(L,&ctx);
    result = lua_pcallk(_vm, 0, 0, en, 0 , 0);

    removeMessageHandler(en);


    // If we are here, it means there has been an error
    if(result != LUA_OK)
    {
        setErrorDescription(result);
        #ifdef FUS_LUA_EXCEPTION
//        throw CLuaException( getErrorDescription() );
        #endif
        //_LOG_ERROR << "Error happened while executing";

        return false;
    }

    return true;
}







// Push chunk onto stack
bool
CLuaVM::loadChunkFromGlobals(const int& index)
{
    //lua_copy();
    //lua_pushvalue()
    //return execute();
//    lua_pushinteger( _vm, index);
//    lua_gettable (_vm, LUA_GLOBALSINDEX);
    //lua_pushinteger( _vm, index);
    //lua_gettable (_vm, -1);
    return false;
}


bool
CLuaVM::loadString(const char* str)
{
//    FUS_ASSERT(str);

    int ret = luaL_loadstring( _vm , str);

    if(ret != LUA_OK)
    {

        setErrorDescription(ret);
        _errorMessage << "Error while luaL_loadstring( " << str << ")";
        return false;
    }
    return true;
}

//int
bool
CLuaVM::loadFile(const char* filename,const char* mode)
{

//    FUS_ASSERT(filename && "No filename to load from");
    // TODO RunFunctionFromChunk
    //loadChunkFromGlobals
    int ret = luaL_loadfilex( _vm , filename, mode);

    if(ret != LUA_OK)
    {

        setErrorDescription(ret);
        _errorMessage << "Error while luaL_loadfilex( " << filename << ")";
        return false;
    }
    return true;
}


//bool
//CLuaVM::RunCommand(const char* param)
//{
//
//    int ret = luaL_loadstring( getVM(), param );
//    if( ret != 0)
//    {
//        setErrorDescription(ret);
//        //_LOG_DEBUG << "TODO Lua could not load string";
//        return false;
//    }
//
//    return execute();
//}
/**
TODO si fichier corrompu alors interrompre le fichier puis le recharger quand modifié
**/
bool
CLuaVM::RunFile(const char* param )
{


	// on peut supprimer  le try/Catch car pas cense lance d'exception
//certainement
    return (loadFile(param,"bt") && execute(0,0) );

}



//std::string
//CLuaVM::retrieveStringFromTopOfStack() {
//
//}

//std::string
void
CLuaVM::setErrorDescription(const int& ret)
{

    bool retrieveErrorMsgFromStack = false;

    _errorMessage.clear();

    std::string msg;
    switch( ret )
    {

        // tt est ok
        case LUA_YIELD :
            //LUA_ERROK
        case 0:
            return;
            //break; //return true;

        case LUA_ERRERR:
            msg = "LUA_ERRERR: error while running error handler";
            break;

        case LUA_ERRMEM:
            msg = "LUA_ERRMEM: Memory allocation error";
            break;

        case LUA_ERRRUN:
            // TODO : la vm n'arrete pas de grossir, elle a plein de nil qui s'ajoute
            msg = "LUA_ERRRUN: Runtime error.";// + lua_gettop(_vm->getVM() );
            retrieveErrorMsgFromStack = true;
            //stack size before from_stack


            //CLuaVM::handleError(_vm->getVM() );
            //_LOG_WARNING << "Should print stack";
            break;

        case LUA_ERRFILE:
            msg = "LUA_ERRFILE: Could not find file";
            break;

        case LUA_ERRSYNTAX:
           msg = "LUA_ERRSYNTAX: Syntax error during pre-compilation";
           retrieveErrorMsgFromStack = true;
           break;

        default:
            msg = "Unhandled lua error";
            //msg += ret;
            //std::cout << " ret" <<  ret;
           break;
    }

    // If error message should be on top of stack then we try to retrieve it
    if(retrieveErrorMsgFromStack)
    {
        retrieveStringFromStack(msg);
    }


    //return msg;
    // TODO a modifier
    /*
    std::string temp;
    if(!handleError( getVM(), temp)){

        //msg.append("Could not retrieve error from stack");
        msg.append(temp);
    }
    else {
        msg.append(temp);
    }
        */
    _errorMessage <<  msg;
}







void
CLuaVM::reset()
{


    if( _vm )
    {
        lua_close(_vm);
    }
    createVM();
}



/**
should return an error code
**/
bool
CLuaVM::handleError(lua_State* state,std::string& errorDescription)
{


    lua_Debug d;

    fus::TCharStringBuilder stream("");
    // 2nd parameter is the level of function 0 => current function
    // n+1 level calls level nfunction

    // recupere le message de debug implante par lua
    luabind::object obj(luabind::from_stack(state, -1) );

    if(lua_getstack(state, 1, &d) !=  1 )
    {

        errorDescription = "Could not retrieve item from stack at level [1]. Dump stack... ";
        //int top = lua_gettop(L);

        stackDump(state);
        return false;
    }

    // could dumpa stack


    //Returns information about a specific function or function invocation
    // must be called with a valid lua_Debug,
    // 's','l','n' fills certain fields of lua_Debug
    // l => line
    // Returns 0 on error
 //object error_stream(from_stack(e.state(), -1));

    // regarder ici comment on pop le message pr en pusher un plus complet
    // http://www.rasterbar.com/products/luabind/docs.html#error-handling
    if(lua_getinfo(state, "Sln", &d) == 0)
    {
        //stream();
        errorDescription = "Couldn't retrieve info from stack";
        return false;
    }

//a "printable" version of source d.short_src

    std::string src(d.source);
    // if true, then we have the filename
    // otherwise it is the string defining function
    if( !src.empty() && src[0] == '@')
    {
        //
        //src =
        stream("Line [")( d.currentline );
        stream("] of file ");//("\" in code:\n");

    }
    else
    {
        stream("In code \n");
    }

    stream(d.short_src)
    ("\nDescription of the problem:\t")("\n");
    stream(obj);
    //(lua_tostring(mLuaState, -1))

    // name is a reasonable name for a function
    // namewhat a more descriptible
    if (d.name != 0)
    {
        try {
            stream("(")( d.namewhat )( " " )(d.name)(")");
        }
        catch(std::exception& e)
        {
            _LOG_ERROR << "Lua error:";
        }
    }
    else
    {
        stream("d.name == 0");
    }

//int luaL_LOG_ERROR (lua_State *L, const char *fmt, ...);
    //lua_pushstring(mLuaState, stream.str().c_str());
    //_errorMessage = stream.str();//lua_tostring(mLuaState,-1);
    errorDescription = stream.str() ;

    return true;
}







}
