uniform sampler2D RTScene; // this should hold the texture rendered by the horizontal blur pass
varying vec2 vTexCoord;

// unsigned int i = int
uniform float vBlurDelta;

//const float blurSize = 1.0/480.0;

void main(void)
{

    vec4 sum = vec4(0.0);

    float blurSize = vBlurDelta;
//    vBlurDelta = blurSize;

    vec2 texCoords = gl_TexCoord[0].st;

    // blur in y (vertical)
    // take nine samples, with the distance blurSize between them
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y - 4.0*blurSize)) * 0.05;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y - 3.0*blurSize)) * 0.09;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y - 2.0*blurSize)) * 0.12;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y - blurSize)) * 0.15;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y)) * 0.18;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y + blurSize)) * 0.15;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y + 2.0*blurSize)) * 0.12;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y + 3.0*blurSize)) * 0.09;
    sum += texture2D(RTScene, vec2(texCoords.x, texCoords.y + 4.0*blurSize)) * 0.05;

    gl_FragColor = sum;
}
